#
# Based off of Dasher's LoadExtraPlugins based off of Banbury's GetShipList()
#

MODINFO = { "Author": "\"Defiant\" mail@defiant.homedns.org",
            "Download": "http://defiant.homedns.org/~erik/STBC/Engineering/",
            "Version": "0.6",
            "License": "GPL",
            "Description": "This is to load the files in scripts/Custom/QBautostart/"
            }

EngineeringInit = 0

def ImportQBautostart(QBrestart=0):
	dir = "scripts\\Custom\\QBautostart"

	import nt
	import string
        import Lib.LibEngineering
        
        global EngineeringInit
        if (EngineeringInit == 1 and QBrestart == 0):
            return
        
        pluginsLoaded = {}
	list = nt.listdir(dir)
	list.sort()

	dotPrefix = string.join(string.split(dir, '\\')[1:], '.') + '.'

        #print("Loading QBautostart")
        
	for plugin in list:
		s = string.split(plugin, '.')
		if len(s) <= 1:
			continue
		# Indexing by -1 lets us be sure we're grabbing the extension. -Dasher42
		extension = s[-1]
		fileName = string.join(s[:-1], '.')

		# We don't want to accidentally load the wrong ship.
		if ((extension == 'pyc' or extension == 'py') and not pluginsLoaded.has_key(fileName)):
                    pluginsLoaded[fileName] = 1 # save, so we don't load twice.
                    pModule = __import__(dotPrefix + fileName)
                    if (QBrestart != 1) and (fileName != "__init__") and not hasattr(pModule, "init"):
                        ModVersion = ""
                        ModAuthor = "."
                        ModHP = ""
                        # TODO: Refuse to load files that are causing this trouble.
                        # We will do this later, when most people got the chance to upgrade to this Version
                        if hasattr(pModule, "MODINFO"):
                            MODINFO = pModule.MODINFO
                            if MODINFO.has_key("Author"):
                                ModAuthor = ": " + str(MODINFO["Author"])
                            if MODINFO.has_key("Version"):
                                ModVersion = " - Version" + str(MODINFO["Version"]) + " -"
                            if MODINFO.has_key("Download"):
                                ModHP = " from " + str(MODINFO["Download"])
                        Lib.LibEngineering.CreateInfoBox("file scripts/Custom/QBautostart/" + str(fileName) + "." + str(extension) + ModVersion + " has no init attribute.\nPlease update this Mod" + ModHP + " or contact the Author" + ModAuthor + "\nElse you should delete or disable this file.")
                    if (QBrestart == 1):
                        if hasattr(pModule , "Restart"):
                            pModule.Restart() # just restart
                    elif (hasattr(pModule , "init")):
                        pModule.init() # init the file
